package jp.gihyo.mitoma.careMedicalV01.model;
import java.util.ArrayList;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
/* *******************************************************************
 * ǎ҂܂
   * @@@R[h̐͏Ж{ōsƂƂAR[h̃Rg͍ŏɂĂ܂B
 *@@@̏ڍא͏ЂB 
 *********************************************************************/
public class MedicalDAO implements MedDAOInterface{
	private SQLiteDatabase db;
    private final static String DB_TABLE = "medical";
    /* *********************************************
     * RXgN^
     ************************************************/
    public MedicalDAO(Context context){
    	this.db=DbConnect.getInstance(context)
    			.getWritableDatabase();
    }
    /* *********************************************
     * Nf[^
     ************************************************/
    public MedicalDTO selectOne(String memNo,String date,String planNo){
    	MedicalDTO dto=null;
     	String[] select={"memNo","memName","date",
    			"time","planNo","bloodu","bloodl","pulse",
    			"height","weight","observ","helperCode","helperName"};
    	String where="memNo=? AND date=? AND planNo=?";
    	String[] whereArgs=new String[3];
    	whereArgs[0]=memNo;
    	whereArgs[1]=date;
    	whereArgs[2]=planNo;
    	String groupBy=null;
    	String having=null;
    	String orderBy=null;
        Cursor cursol=db.query(DB_TABLE,select,where,whereArgs,groupBy,having,orderBy);
       if(cursol.moveToFirst()){
    	   dto=new MedicalDTO();
	        dto.setMemNo(cursol.getString(0));
	        dto.setMemName(cursol.getString(1));
	        dto.setDate(cursol.getString(2));
	        dto.setTime(cursol.getString(3));
	        dto.setPlanNo(cursol.getString(4));
	        dto.setBloodU(cursol.getString(5));
	        dto.setBloodL(cursol.getString(6));
	        dto.setPulse(cursol.getString(7));
	        dto.setHeight(cursol.getString(8));
	        dto.setWeight(cursol.getString(9));
	        dto.setObserv(cursol.getString(10));
	        dto.setHelperCode(cursol.getString(11));
	        dto.setHelperName(cursol.getString(12));
	    }
        cursol.close();
        return dto;
    }
    /* *********************************************
    * Nf[^(Rw)
    ************************************************/
    public ArrayList<MedicalDTO> selectAny(String where){
    	MedicalDTO dto;
    	ArrayList<MedicalDTO> careList=new ArrayList<MedicalDTO>();
    	String[] select={"memNo","memName","date",
    			"time","planNo","bloodu","bloodl","pulse",
    			"height","weight","observ","helperCode","helperName"};
    	String[] whereArgs=null;
    	String groupBy=null;
    	String having=null;
    	String orderBy=null;
        Cursor cursol=db.query(DB_TABLE,select,where,whereArgs,groupBy,having,orderBy);
       while(cursol.moveToNext()){
    	   dto=new MedicalDTO();
    	   dto.setMemNo(cursol.getString(0));
	        dto.setMemName(cursol.getString(1));
	        dto.setDate(cursol.getString(2));
	        dto.setTime(cursol.getString(3));
	        dto.setPlanNo(cursol.getString(4));
	        dto.setBloodU(cursol.getString(5));
	        dto.setBloodL(cursol.getString(6));
	        dto.setPulse(cursol.getString(7));
	        dto.setHeight(cursol.getString(8));
	        dto.setWeight(cursol.getString(9));
	        dto.setObserv(cursol.getString(10));
	        dto.setHelperCode(cursol.getString(11));
	        dto.setHelperName(cursol.getString(12));
	       careList.add(dto);
        }
        cursol.close();
        return careList;
    }
    /* *********************************************
    * Nf[^P폜
    ************************************************/
    public int deleteOne(String memNo,String date,String planNo){ 
    	String where="memNo=? AND date=? AND planNo=?";
    	String[] whereArgs=new String[3];
    	whereArgs[0]=memNo;
    	whereArgs[1]=date;
    	whereArgs[2]=planNo;
    	return db.delete(DB_TABLE,where,whereArgs);
    }
    /* *********************************************
     * Nf[^S폜
     ************************************************/
    public int deleteAll(){    	
    	return db.delete(DB_TABLE,null,null);
    }
    /* *********************************************
     * Nf[^ǉ
     ************************************************/
    public int insertOne(MedicalDTO dto){
    	ContentValues values=new ContentValues();    	
        values.put("memNo",dto.getMemNo());
        values.put("memName",dto.getMemName());        
        values.put("date",dto.getDate());
        values.put("time",dto.getTime());
        values.put("planNo",dto.getPlanNo());
        values.put("bloodu",dto.getBloodU());
        values.put("bloodl",dto.getBloodL());
        values.put("pulse",dto.getPulse());
        values.put("height",dto.getHeight());
        values.put("weight",dto.getWeight());
        values.put("observ",dto.getObserv());
        values.put("helperCode",dto.getHelperCode());
        values.put("helperName",dto.getHelperName());
        return (int)db.insert(DB_TABLE,null,values);
    }
    /* *********************************************
     * Nf[^PXV
     ************************************************/
    public int updateOne(MedicalDTO dto){
    	String where="memNo=? AND date=? AND planNo=?";
    	String[] whereArgs=new String[3];
    	whereArgs[0]=dto.getMemNo();
    	whereArgs[1]=dto.getDate();
    	whereArgs[2]=dto.getPlanNo();
        ContentValues values=new ContentValues();
        values.put("memNo",dto.getMemNo());
        values.put("memName",dto.getMemName());        
        values.put("date",dto.getDate());
        values.put("time",dto.getTime());
        values.put("planNo",dto.getPlanNo());
        values.put("bloodu",dto.getBloodU());
        values.put("bloodl",dto.getBloodL());
        values.put("pulse",dto.getPulse());
        values.put("height",dto.getHeight());
        values.put("weight",dto.getWeight());
        values.put("observ",dto.getObserv());
        values.put("helperCode",dto.getHelperCode());
        values.put("helperName",dto.getHelperName());
        return db.update(DB_TABLE,values,where,whereArgs);
    }
}
