package jp.gihyo.mitoma.careMember.model;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import android.content.Context;
import android.util.Log;
/* *******************************************************************
 * ǎ҂܂
   * @@@R[h̐͏Ж{ōsƂƂAR[h̃Rg͍ŏɂĂ܂B
 *@@@̏ڍא͏ЂB 
 *********************************************************************/
public class MemberFileDAO implements MemberDAOInterface{
	private final static String TAG="MemberFileDAO";
	private String strage;
	private final static String directry="/user_gihyo";
	private String fileName;
	private String code;
	private Context context;
    public MemberFileDAO(Context context,String strage,String fileName,String code){
    	this.context=context;
    	this.strage=strage;
    	this.fileName=fileName;
    	this.code=code;
    }    
    public ArrayList<MemberDTO> selectSome(String[] terms){
    	ArrayList<MemberDTO> list=new ArrayList<MemberDTO>();
    	BufferedReader br=null;
    	try {
    		br=openReader();
    		String buf;
    		boolean eof=false;
	        while(!eof){
	        	buf=br.readLine();
	        	if(buf!=null){
	        		String[] item=buf.split(",");
	        		MemberDTO dto=new MemberDTO();
			        dto.setMemNo(item[0]);
			        dto.setMemName(item[1]);
			        dto.setMemGender(item[2]);
			        dto.setMemBirthday(item[3]);
			        dto.setMemPref(item[4]);
			        dto.setMemEmail(item[5]);
			        dto.setMemTel(item[6]);
			        dto.setMemLevel(item[7]);
			        dto.setMemLatitude(item[8]);
			        dto.setMemLongitude(item[9]);
			        list.add(dto);
	        	}else{
	        		eof=true;
	        	}	        	
	        }	                
    	}catch(Exception e){
    		Log.e(TAG,e.getMessage());
    		list=null;
    	}finally{
    		try{
    		 br.close();
    		}catch(IOException e){
    			Log.e(TAG,e.getMessage());
    		}
    	}    	
    	return list;
    }
    public int insertSome(ArrayList<MemberDTO> list){
    	 MemberDTO dto;
    	 BufferedWriter bw=null;
    	 int count=0;
    	 String buf;
    	 try{
    		 bw=openWriter();
    		 for(int i=0;i<list.size();i++){
    			 dto=list.get(i);
    			 buf=dto.getMemNo()+","+dto.getMemName()+","+dto.getMemGender()+
    					 ","+dto.getMemBirthday()+","+dto.getMemPref()+
    					 ","+dto.getMemEmail()+","+dto.getMemTel()+
    					 ","+dto.getMemLevel()+
    					 ","+dto.getMemLatitude()+","+dto.getMemLongitude()+",";
    			 bw.write(buf);
    			 bw.newLine();
    			 bw.flush();
    			 count+=1;
    		 }    		
         }catch(Exception e){
        	 Log.e(TAG,e.getMessage());
        	 count=-1;
         }finally{
        	 try{
        		 bw.close();
        	 }catch(IOException e){
     			Log.e(TAG,e.getMessage());
        	 }
         }
    	 return count;
    }
    public int deleteAll(){
    	if(this.strage.equals("internal")){
    		File userFile=this.context.getFileStreamPath("test.txt");
    		if(userFile!=null)userFile.delete();
    	}else if(this.strage.equals("external")){
    		File sdDir=new File("/sdcard/");
    		if(!(sdDir.exists() && sdDir.canWrite()))return -1;
    		File userDir=new File(sdDir.getAbsolutePath()+directry);
    		File userFile=new File(userDir.getAbsolutePath()+"/"+this.fileName);
    		if(userFile.exists())userFile.delete();
    		userDir.delete();
    	}
    	return 1;
    }
    public MemberDTO selectOne(String key){
    	//
        return null;
    }
    public int delete(String key){
    	//
    	return 0;
    }    
    public int insert(MemberDTO dto){
    	//
    	return 0;
    }
    public int update(MemberDTO dto){
    	//
		return 0;
    }
    private BufferedWriter openWriter()throws Exception{
    	BufferedWriter bw=null;
    	if(this.strage.equals("internal")){
    		FileOutputStream fos=this.context.openFileOutput(this.fileName,Context.MODE_APPEND);
    	    bw=new BufferedWriter(new OutputStreamWriter(fos,"UTF-8"));
    	}else if(this.strage.equals("external")){
    		File sdDir=new File("/sdcard/");
    		if(!(sdDir.exists() && sdDir.canWrite()))return null;
    		File userDir=new File(sdDir.getAbsolutePath()+directry);
    		if(!userDir.exists())userDir.mkdir();
    		File userFile=new File(userDir.getAbsolutePath()+"/"+this.fileName);
    		if(!userFile.exists())userFile.createNewFile();
    		FileOutputStream fos=new FileOutputStream(userFile);
    		bw=new BufferedWriter(new OutputStreamWriter(fos,this.code));    		
    	}
    	return bw;
    }
    private BufferedReader openReader()throws Exception{
    	BufferedReader br=null;
    	if(this.strage.equals("internal")){
    		FileInputStream fis=this.context.openFileInput(this.fileName);
    	    br=new BufferedReader(new InputStreamReader(fis,code));
    	}else if(this.strage.equals("external")){
    		File userFile=new File("/sdcard"+directry+"/"+this.fileName);
    		FileInputStream fis=new FileInputStream(userFile);
    		br=new BufferedReader(new InputStreamReader(fis,this.code));    		
    	}
    	return br;
    }    
}
