package jp.gihyo.mitoma.careMember.service;

import java.util.ArrayList;
import java.util.List;

import jp.gihyo.mitoma.careMember.MemberBindService;
import jp.gihyo.mitoma.careMember.model.MemberDTO;
import jp.gihyo.mitoma.careMember.model.MemberWebDAO;
import jp.gihyo.mitoma.careMember.R;
import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.os.IBinder;
import android.os.RemoteException;
import android.util.Log;
/* *******************************************************************
 * ǎ҂܂
   * @@@R[h̐͏Ж{ōsƂƂAR[h̃Rg͍ŏɂĂ܂B
 *@@@̏ڍא͏ЂB 
 *********************************************************************/
public class MemberService extends Service implements Runnable{
    private Thread thread;
    private MemberWebDAO webDAO;
    private boolean webStatus;
    final static String INSERT="jp.gihyo.mitoma.careMember.INSERT";
    final static String UPDATE="jp.gihyo.mitoma.careMember.UPDATE";
    final static String DELETE="jp.gihyo.mitoma.careMember.DELETE";
    
    @Override
    public void onCreate(){
    	Log.d("MemberService", "Create now");
    	this.thread=null;
    	this.webDAO=new MemberWebDAO(this,false);
    	this.webStatus=true;
    }
    @Override
    public void onStart(Intent intent,int startID) {
    	Log.d("MemberService", "Start now");
    	while(!Queue.getInstance().enq(intent)){
    		Log.d("MemberService", "Wait now");
    		try{Thread.sleep(2000);}catch(Exception e){}
    	}
    	if(this.thread ==null){
    		this.thread=new Thread(this);
    		this.thread.start();
    	}    	
    }
    @Override
    public void onDestroy() {
    	super.onDestroy();
    	Log.d("MemberService", "Destroy now");
    	this.thread=null;
    }
	public void run() {		
		int retry=0;
		checkQueue();
		while(retry++<5){
			Intent intent=Queue.getInstance().deq();			
	    	while(intent!=null){
	    		Log.d("MemberService", "Running now "+intent.getStringExtra("procType"));
	    		MemberDTO memDTO=(MemberDTO) intent.getSerializableExtra("memberDTO");
	    		if(memDTO==null)continue;
	    		if(intent.getAction().equals(INSERT))webDAO.insert(memDTO);
	    		if(intent.getAction().equals(UPDATE))webDAO.update(memDTO);
	    		if(intent.getAction().equals(DELETE))webDAO.delete(memDTO.getMemNo());
	    		intent=Queue.getInstance().deq();
	    		retry=0;
	    		checkQueue();
	    	}
	    	Log.d("MemberService", "Sleep now "+retry);
	    	try{Thread.sleep(3000);}catch(Exception e){}
		}
    	Log.d("MemberService", "Stop now");
    	stopSelf();
	}
    @Override
    public IBinder onBind(Intent intent) {
    	Log.d("MemberService", "Bind now");
        return bindInf;
    }
    private MemberBindService.Stub bindInf=new MemberBindService.Stub(){
    	public boolean isWebStatus() throws RemoteException{
    		MemberService.this.webStatus=true; //debug aide
    		return MemberService.this.webStatus;
    	}
    	public List<String> getQueue() throws RemoteException{
    		ArrayList<Intent> sourceArray=Queue.getInstance().getArray();
    		ArrayList<String> distArray=new ArrayList<String>();

    		for(int i=0;i<sourceArray.size();i++){
    			Intent intent=sourceArray.get(i);    
    			MemberDTO memDTO=(MemberDTO) intent.getSerializableExtra("memberDTO");
    			String str=intent.getStringExtra("time")+" "+intent.getStringExtra("procType") ;
    			str=str+" "+memDTO.getMemNo()+" "+memDTO.getMemName();
    			distArray.add(str);
    		}
    		return distArray;
    	}
    };
    @Override
    public boolean onUnbind(Intent intent) {
    	super.onUnbind(intent);
    	Log.d("MemberService", "Unbind now");
        return true;
    }
    private void checkQueue(){
    	NotificationManager nm=(NotificationManager)getSystemService(Context.NOTIFICATION_SERVICE);
    	if(Queue.getInstance().getArray().size()<1)return;
    	if(Queue.QUEUE_SIZE/Queue.getInstance().getArray().size()<2){
	  		Notification notif=new Notification();
	  		notif.icon=R.drawable.caution;
	  		notif.number=Queue.getInstance().getArray().size();
	  		notif.defaults |=Notification.DEFAULT_SOUND;
	  		notif.flags |=Notification.FLAG_AUTO_CANCEL;
	  		notif.when=System.currentTimeMillis();
	  		PendingIntent pi = 
		            PendingIntent.getActivity(getApplicationContext(), 0, new Intent(), 0);
	  		notif.setLatestEventInfo(getApplicationContext(), "T[ȏ","XV}ĉB", pi);
	  		nm.notify(0, notif);
    	}else nm.cancel(0);
    }
}

class Queue{
	private static ArrayList<Intent> array; 
	private static Queue instance=null;
	final static int QUEUE_SIZE=10;
	private Queue(){
    	array=new ArrayList<Intent>();
    }
	public static synchronized Queue getInstance(){
    	if(instance==null){
    		instance=new Queue();
    	}
    	return instance;
    }
	public synchronized Intent deq(){
		Intent intent=null;
		if(!array.isEmpty()){
			intent=array.get(0);
			array.remove(0);
			array.trimToSize();
		}
		return intent;
	}
	public synchronized boolean enq(Intent intent){
		if(array.size()>=QUEUE_SIZE)return false;
		array.add(intent);
		return true;
	}
	public ArrayList<Intent> getArray(){return array; } 	
}
class QueueEXX{
	private static Intent intentArray[];
	private static int enqCtr;
	private static int deqCtr;
	private static boolean flag;
	private static QueueEXX instance=null;
	final static int QN=10;
	private QueueEXX(){
    	enqCtr=0;
    	deqCtr=0;
    	flag=false;
    	intentArray=new Intent[QN];
    }
	public static synchronized QueueEXX getInstance(){
    	if(instance==null){
    		instance=new QueueEXX();
    	}
    	return instance;
    }
	public synchronized Intent deq(){
		Intent intent=null;
		if((enqCtr!=deqCtr)||(enqCtr==deqCtr&&flag))intent=intentArray[deqCtr++];
		if(deqCtr==QN){
			deqCtr=0;
			flag=false;
		}
		return intent;
	}
	public synchronized boolean enq(Intent intent){
		if((enqCtr!=deqCtr)||(enqCtr==deqCtr&&!flag)){
			intentArray[enqCtr++]=intent;
			if(enqCtr==QN){
				enqCtr=0;
				flag=true;
			}
			return true;
		}else return false;
	}
}
