package jp.gihyo.mitoma.careTimer.activity;

import java.util.ArrayList;
import java.util.Calendar;

import jp.gihyo.mitoma.careTimer.activity.model.CareBean;
import jp.gihyo.mitoma.careTimer.activity.model.CareDTO;
import jp.gihyo.mitoma.careTimer.util.DialogUtil;
import jp.gihyo.mitoma.careTimer.R;
import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.text.format.DateFormat;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
/* *******************************************************************
 * ǎ҂܂
   * @@@R[h̐͏Ж{ōsƂƂAR[h̃Rg͍ŏɂĂ܂B
 *@@@̏ڍא͏ЂB 
 *********************************************************************/
public class CareControl extends Activity{
    private CareView view;
    private CareBean bean;
    private String date;
    private String memNo;
    private String memName;
    private BroadcastReceiver localReceiver = new BroadcastReceiver() {
		@Override
		public void onReceive(Context context, Intent intent) {
			view.setHeader(bean);
	    	view.refresh();
		}
	};
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        Calendar now = Calendar.getInstance();
    	this.date=(String) DateFormat.format(this.getString(R.string.fdate_f),now);
    	if(PreferencesCont.getMemberNo(this).equals("none"))DialogUtil.showDialog(this, "xI", "{ݒĉ");
    }
    @Override
    public void onResume() {
        super.onResume();
        this.memNo=PreferencesCont.getMemberNo(this);
    	this.memName=PreferencesCont.getMemberName(this);
        view=new CareView(this);        
    	bean=new CareBean(this,this.memNo,this.date);    	
    	if(!bean.isCareExist()){
    		DialogUtil.showDialog(this, "xI", "vȂ");
    		bean.setMemNo(this.memNo);
    		bean.setMemName(this.memName);
    	}
    	bean.setHelperCode(PreferencesCont.getHelpreCode(this));
    	bean.setHelperName(PreferencesCont.getHelpreName(this));
    	bean.setDate(this.date);
    	view.setHeader(bean);
    	view.setDetail(bean.getCareMatter());
    	//CareService Start
    	if(PreferencesCont.isService(this)){
	    	Intent intent=new Intent();
	    	intent.setAction("jp.gihyo.mitoma.careTimer.CARE_SERVICE");
	    	startService(intent);
    	}else{
    		Intent intent=new Intent();
        	intent.setAction("jp.gihyo.mitoma.careTimer.CARE_SERVICE");
        	stopService(intent);
    	}
    	this.receiverStart();
    }
    @Override
    public void onPause() {
        super.onPause();
        ArrayList<CareDTO> perform=view.getDetail();        
        bean.setCareMatter(perform);
        bean.careUpdate();
        this.receiverStop();
    }
    @Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
	  	super.onCreateOptionsMenu(menu);
	  	MenuInflater inflater = getMenuInflater();
	  	inflater.inflate(R.menu.care_main, menu);
	  	return true;
	}
  	@Override
  	public boolean onOptionsItemSelected(MenuItem item) {
  	  	super.onOptionsItemSelected(item);
  	  	Intent intent;
  	  	switch (item.getItemId()){
  	  	case R.id.optmenu_schedule:
  	  		intent = new Intent(this, jp.gihyo.mitoma.careTimer.activity.CarePlanControl.class);
  	  		intent.putExtra("memNo", bean.getMemNo());
	  		intent.putExtra("memName", bean.getMemName());
  	  		startActivity(intent);
  	  		break;
  	  	case R.id.optmenu_member:
			intent = new Intent("jp.gihyo.mitoma.careMember.MAIN_VIEW");
	  		startActivity(intent);
	  		break;
  		case R.id.optmenu_history:
  			intent = new Intent(this, jp.gihyo.mitoma.careTimer.activity.CareHistoryCont.class);
  	  		startActivity(intent);
  	  		break;
  		case R.id.optmenu_preferences:
  	  		intent = new Intent(this, jp.gihyo.mitoma.careTimer.activity.PreferencesCont.class);
  	  		startActivity(intent);
  	  		break;
  	  	case R.id.optmenu_close:
  	  		finish();
  	  		break;
  	  	}	  	
  	  	return true;
  	}
    public void onTouch(View v) {
    	view.dialogInput(v);
        ArrayList<CareDTO> perform=view.getDetail();
        bean.setCareMatter(perform);
        bean.careUpdate();
    }
    private void receiverStart(){
    	IntentFilter filter = new IntentFilter();
		filter.addAction(Intent.ACTION_TIME_TICK);
		registerReceiver(localReceiver, filter);
    }
    private void receiverStop(){
		unregisterReceiver(localReceiver);
    }
}