package jp.gihyo.mitoma.careTimer.activity;

import java.util.ArrayList;
import java.util.Calendar;
import jp.gihyo.mitoma.careTimer.activity.model.CareBean;
import jp.gihyo.mitoma.careTimer.activity.model.CareDTO;
import jp.gihyo.mitoma.careTimer.util.DialogUtil;
import jp.gihyo.mitoma.careTimer.R;

import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.text.format.DateFormat;
import android.view.GestureDetector;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.View;
import android.view.GestureDetector.OnGestureListener;
/* *******************************************************************
 * ǎ҂܂
   * @@@R[h̐͏Ж{ōsƂƂAR[h̃Rg͍ŏɂĂ܂B
 *@@@̏ڍא͏ЂB 
 *********************************************************************/
public class CareControl extends Activity implements OnGestureListener{
    private CareView view;
    private CareBean bean;
    private String date;
    private String defaultMemNo;
    private GestureDetector detector;
    //񃌃V[o
    private BroadcastReceiver localReceiver = new BroadcastReceiver() {
		@Override
		public void onReceive(Context context, Intent intent) {
			view.setHeader(bean);
	    	view.refresh();
		}
	};
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        Calendar now = Calendar.getInstance();
    	this.date=(String) DateFormat.format(this.getString(R.string.fdate_f),now);
    	this.defaultMemNo=PreferencesCont.getMemberNo(this);
    	this.detector=new GestureDetector(this,this);
    	//̃Av̋N̏ꍇ̑Ή(̎dlύXւ̔)
    	Intent intent=getIntent();
    	if(intent.getAction()!=null){    		
    		if(intent.getStringExtra("memNo")!=null)
    			this.defaultMemNo=intent.getStringExtra("memNo");
    	}
    }
    @Override
    public void onResume() {
    	//ʂ̕\
        super.onResume();
        view=new CareView(this);
    	bean=new CareBean(this,this.defaultMemNo,this.date);    	
    	if(!bean.isCareExist()){
    		DialogUtil.showDialog(this, "xI", "vȂ");    		
    	}
    	bean.setHelperCode(PreferencesCont.getHelpreCode(this));
    	bean.setHelperName(PreferencesCont.getHelpreName(this));
    	bean.setDate(this.date);
    	view.setHeader(bean);
    	view.setDetail(bean.getCareMatter());
    	//T[rX̊Jn
    	if(PreferencesCont.isService(this)){
	    	Intent intent=new Intent();
	    	intent.setAction("jp.gihyo.mitoma.careTimer.CARE_SERVICE");
	    	startService(intent);
    	}else{
    		Intent intent=new Intent();
        	intent.setAction("jp.gihyo.mitoma.careTimer.CARE_SERVICE");
        	stopService(intent);
    	}
    	//񃌃V[o̊Jn
    	this.receiverStart();
    }
    @Override
    public void onPause() {
        super.onPause();
        ArrayList<CareDTO> perform=view.getDetail();
        //DBXVc̏
        bean.setCareMatter(perform);
        bean.careUpdate();
        //񃌃V[o̒~
        this.receiverStop();
    }
    /* **********************************************************
     * IvVj[
     *************************************************************/
    //j[\
    @Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
	  	super.onCreateOptionsMenu(menu);
	  	MenuInflater inflater = getMenuInflater();
	  	inflater.inflate(R.menu.care_main, menu);
	  	return true;
	}
    //j[ICxg
  	@Override
  	public boolean onOptionsItemSelected(MenuItem item) {
  	  	super.onOptionsItemSelected(item);
  	  	Intent intent;
  	  	switch (item.getItemId()){
  	  	//v
  	  	case R.id.optmenu_schedule:
  	  		intent = new Intent("jp.gihyo.mitoma.carePlan.MAIN_VIEW");
  	  		intent.putExtra("memNo", bean.getMemNo());
	  		intent.putExtra("memName", bean.getMemName());
  	  		startActivity(intent);
  	  		break;
  	  	//L^
  		case R.id.optmenu_history:
  			intent = new Intent(this, jp.gihyo.mitoma.careTimer.activity.CareHistoryCont.class);
  	  		startActivity(intent);
  	  		break;
  	  	//L^
  		case R.id.optmenu_member:
  			intent = new Intent("jp.gihyo.mitoma.careMember.MAIN_VIEW");
  	  		startActivity(intent);
  	  		break;
  	  	//{ݒ
  		case R.id.optmenu_preferences:
  	  		intent = new Intent(this, jp.gihyo.mitoma.careTimer.activity.PreferencesCont.class);
  	  		startActivity(intent);
  	  		break;
  	  	//
  	  	case R.id.optmenu_close:
  	  		finish();
  	  		break;
  	  	}	  	
  	  	return true;
  	}
  	/* **********************************************************
     * ^b`Cxg
     *************************************************************/
    public void onTouch(View v) {
    	view.dialogInput(v);
        ArrayList<CareDTO> perform=view.getDetail();
        bean.setCareMatter(perform);
        bean.careUpdate();
    }
    /* **********************************************************
     * 񃌃V[o
     *************************************************************/
    //Jn
    private void receiverStart(){
    	IntentFilter filter = new IntentFilter();
		filter.addAction(Intent.ACTION_TIME_TICK);
		registerReceiver(localReceiver, filter);
    }
    //~
    private void receiverStop(){
		unregisterReceiver(localReceiver);
    }
    /* **********************************************************
     * WFX`[
     *************************************************************/
    @Override
    public boolean onTouchEvent(MotionEvent event){
    	detector.onTouchEvent(event);
      	super.onTouchEvent(event);
    	return true;
    }
	public boolean onDown(MotionEvent e) {return false;}
	//tbN
	public boolean onFling(MotionEvent event0, MotionEvent event1, float xSpeed,
			float ySpeed) {
		//vꗗ擾
		ArrayList<CareDTO> list=this.bean.getPlanGroup(this.date);
		CareDTO careDto=null;
		//tbN
		if(xSpeed<-800){
			//ɐi߂
			for(int i=0;i<list.size();i++){
				careDto=list.get(i);
				if(careDto.getMemNo().compareTo(bean.getMemNo())>0)break;
			}
		}
		//EtbN
		if(xSpeed>800){
			//߂
			for(int i=list.size()-1;i>=0;i--){
				careDto=list.get(i);
				if(careDto.getMemNo().compareTo(bean.getMemNo())<0)break;
			}
		}
		//v̕\
		if(careDto!=null){
			bean=new CareBean(this,careDto.getMemNo(),careDto.getDate()); 
			bean.setHelperCode(PreferencesCont.getHelpreCode(this));
	    	bean.setHelperName(PreferencesCont.getHelpreName(this));
	    	bean.setDate(this.date);
	    	view.setHeader(bean);
	    	view.setDetail(bean.getCareMatter());
		}
		return true;
	}
	//WFX`[̋󃁃\bh
	public void onLongPress(MotionEvent e) {}
	public boolean onScroll(MotionEvent e1, MotionEvent e2, float distanceX,
			float distanceY) {return false;}
	public void onShowPress(MotionEvent e) {}
	public boolean onSingleTapUp(MotionEvent e) {return false;}
}