package jp.gihyo.mitoma.careTimer.activity;

import java.util.ArrayList;
import java.util.Calendar;

import jp.gihyo.mitoma.careTimer.activity.model.CareBean;
import jp.gihyo.mitoma.careTimer.activity.model.CareDTO;
import jp.gihyo.mitoma.careTimer.R;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.text.format.DateFormat;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;
/* *******************************************************************
 * ǎ҂܂
   * @@@R[h̐͏Ж{ōsƂƂAR[h̃Rg͍ŏɂĂ܂B
 *@@@̏ڍא͏ЂB 
 *********************************************************************/
public class CareView{
	private Activity act;	
	private TextView memNo;
	private TextView memName;	
	private TextView today;
	private TextView currentTime;
	private LinearLayout detail;	
	private LinearLayout[] careMatters;
	private String date;
	private String helperCode;
	private String helperName;
	/* **********************************************************
     * RXgN^
     *************************************************************/
    public CareView(Object obj) {    	
        act=(Activity)obj;
        act.setContentView(R.layout.head); 
        LinearLayout base=(LinearLayout)act.findViewById(R.id.base);
        detail=(LinearLayout)base.findViewById(R.id.detail);
        memNo=(TextView)base.findViewById(R.id.memNo);
        memName=(TextView)base.findViewById(R.id.memName);    
        currentTime=(TextView)base.findViewById(R.id.currentTime);
        today=(TextView)base.findViewById(R.id.today);
        careMatters=null;
    }
    /* **********************************************************
     * wb_[̕\
     *************************************************************/
    public void setHeader(CareBean bean){
    	Calendar now = Calendar.getInstance();
    	act.setTitle(bean.getHelperCode()+"  "+bean.getHelperName());
    	today.setText(DateFormat.format(act.getString(R.string.fdate),now));
    	currentTime.setText(DateFormat.format(act.getString(R.string.f12),now));
    	memNo.setText(bean.getMemNo());
    	memName.setText(bean.getMemName());
    	this.date=bean.getDate();
    	this.helperCode=bean.getHelperCode();
    	this.helperName=bean.getHelperName();
    }
    /* **********************************************************
     * 쎖̕\
     *************************************************************/
    public void setDetail(ArrayList<CareDTO> matter){
        LayoutInflater lf1 = (LayoutInflater)act.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        CareDTO care;
        careMatters =new LinearLayout[matter.size()];
        detail.removeAllViews();
        for(int i=0;i<matter.size();i++){
        	care=matter.get(i);        	
        	careMatters[i] = (LinearLayout)(lf1.inflate(R.layout.item, null));
        	((TextView)careMatters[i].findViewById(R.id.careCode)).setText(care.getCareCode());
        	((TextView)careMatters[i].findViewById(R.id.careName)).setText(care.getCareName());
        	((TextView)careMatters[i].findViewById(R.id.predTime)).setText(timeConvAmPm(care.getPredTime()));
        	((TextView)careMatters[i].findViewById(R.id.planNo)).setText(care.getPlanNo());
        	((TextView)careMatters[i].findViewById(R.id.implTime)).setText(timeConvAmPm(care.getImplTime()));
        	((TextView)careMatters[i].findViewById(R.id.result)).setText(care.getResult());        	
        	((LinearLayout)careMatters[i].findViewById(R.id.careItem)).setTag(String.format("%d", i));
        	
        	String pTime=((TextView)careMatters[i].findViewById(R.id.predTime)).getText().toString();
        	String nTime=currentTime.getText().toString();   	
        	((ImageView)careMatters[i].findViewById(R.id.alertIcon))
        	.setImageResource(iconSelect(nTime,pTime,care.getImplTime(),care.getCareCode()));
        	String msg=memoWrite(i);
        	((TextView)careMatters[i].findViewById(R.id.memo)).setText(msg); 
        	detail.addView(careMatters[i]);
        }
    }
    /* **********************************************************
     * 쎖̎擾
     *************************************************************/
    public ArrayList<CareDTO> getDetail(){
    	ArrayList<CareDTO> matterList=new ArrayList<CareDTO>();
    	for(int i=0;i<careMatters.length;i++){
    		CareDTO dto=new CareDTO();
    		dto.setMemNo(this.memNo.getText().toString());
    		dto.setMemName(this.memName.getText().toString());
    		dto.setDate(this.date);
    		dto.setCareCode(((TextView)careMatters[i].findViewById(R.id.careCode)).getText().toString());
    		dto.setCareName(((TextView)careMatters[i].findViewById(R.id.careName)).getText().toString());
    		dto.setPlanNo(((TextView)careMatters[i].findViewById(R.id.planNo)).getText().toString());
    		dto.setPredTime(timeConv24(((TextView)careMatters[i].findViewById(R.id.predTime)).getText().toString()));
    		dto.setImplTime(timeConv24(((TextView)careMatters[i].findViewById(R.id.implTime)).getText().toString()));
    		dto.setResult(((TextView)careMatters[i].findViewById(R.id.result)).getText().toString());
    		dto.setHelperCode(this.helperCode);
    		dto.setHelperName(this.helperName);
    		matterList.add(dto);
    	}    	
    	return matterList;
    }
    /* **********************************************************
     * \tbV
     *************************************************************/
    public void refresh(){
    	//ŐV̎擾ƕ\
    	Calendar now = Calendar.getInstance();
    	String nTime=(String)DateFormat.format(act.getString(R.string.f12),now);
    	currentTime.setText(nTime);
    	//\莞B̉쎖ACRԌnACRɕύX
    	for(int i=0;i<careMatters.length;i++){
    		String pTime=((TextView)careMatters[i].findViewById(R.id.predTime)).getText().toString();
    		String eTime=((TextView)careMatters[i].findViewById(R.id.implTime)).getText().toString();
 	    	((ImageView)careMatters[i].findViewById(R.id.alertIcon))
	    	.setImageResource(iconSelect(nTime,pTime,eTime,
	    			((TextView)careMatters[i].findViewById(R.id.careCode)).getText().toString()));
 	    	String msg=memoWrite(i);
 	    	((TextView)careMatters[i].findViewById(R.id.memo)).setText(msg);
    	}
    }
    /* **********************************************************
     * _CAO
     *************************************************************/
    public void dialogInput(View v){
    	final int line=Integer.parseInt(v.getTag().toString());
    	String careCode=((TextView)careMatters[line].findViewById(R.id.careCode)).getText().toString();
    	//쎖Ƃ̃_CAO̕\
    	if(careCode.equals("M01")){
    		resultInput(R.string.M01,R.array.resultOfMedi,R.drawable.medicine_blue,line);
    	}
    	if(careCode.equals("D01")){
    		resultInput(R.string.D01,R.array.resultOfDiet,R.drawable.diet_blue,line);    		
    	}
    	if(careCode.equals("B01")){
    		resultInput(R.string.B01,R.array.resultOfBath,R.drawable.bath_blue,line);
    	}
    	if(careCode.equals("T01")){
    		resultInput(R.string.T01,R.array.resultOfToilet,R.drawable.toilet_blue,line);
    	}
    	if(careCode.equals("H01")){
    		resultInput(R.string.H01,R.array.resultOfHealth,R.drawable.health_blue,line);
    	}
    	if(careCode.equals("W01")){
    		resultInput(R.string.W01,R.array.resultOfWalk,R.drawable.walk_blue,line);
    	}
    }
    /* **********************************************************
     * 쎖Ƃ̃ACȒI
     *************************************************************/
    private int iconSelect(String nTime,String pTime,String eTime,String careCode){
    	int lateFlag=0,iconNo=0;
    	//\莞B
    	if(timeComp(nTime,pTime)>0)lateFlag=1;    	
    	if(lateFlag==0 && eTime.equals("")){
	    	iconNo=R.drawable.clock_blue;
	    	if(careCode.equals("D01"))iconNo=R.drawable.diet_blue;
	    	if(careCode.equals("M01"))iconNo=R.drawable.medicine_blue;
	    	if(careCode.equals("B01"))iconNo=R.drawable.bath_blue;
	    	if(careCode.equals("T01"))iconNo=R.drawable.toilet_blue;
	    	if(careCode.equals("H01"))iconNo=R.drawable.health_blue;
	    	if(careCode.equals("W01"))iconNo=R.drawable.walk_blue;
	    //\莞B
    	}else if(lateFlag==1 && eTime.equals("")){
	    	iconNo=R.drawable.clock_red;
	    	if(careCode.equals("D01"))iconNo=R.drawable.diet_red;
	    	if(careCode.equals("M01"))iconNo=R.drawable.medicine_red;
	    	if(careCode.equals("B01"))iconNo=R.drawable.bath_red;
	    	if(careCode.equals("T01"))iconNo=R.drawable.toilet_red;
	    	if(careCode.equals("H01"))iconNo=R.drawable.health_red;
	    	if(careCode.equals("W01"))iconNo=R.drawable.walk_red;
	    }else{
    		iconNo=R.drawable.complete;
    	}
    	return iconNo;
    }
    /* **********************************************************
     * _CAO̕\ƃNbNCxg
     *************************************************************/
    private void resultInput(int title,int array,int icon,final int line){
    	final String[] list=act.getResources().getStringArray(array);
    	new AlertDialog.Builder(act)
		.setIcon(icon)
		.setTitle(title)
		.setItems(list, new DialogInterface.OnClickListener() {
			//NbNCxg
			public void onClick(DialogInterface dialog, int which) {
				//Is̓e\
				Calendar now = Calendar.getInstance();
				String time=DateFormat.format(CareView.this.act.getString(R.string.f12),now).toString();
				((TextView)careMatters[line].findViewById(R.id.result)).setText(list[which]);
				//IsNL^̏ꍇ́uNL^vɑJ
				if(list[which].equals("NL^")){
					Intent intent = new Intent("jp.gihyo.mitoma.careMedical.MAIN");
			  		intent.putExtra("memNo",memNo.getText().toString());
			  		intent.putExtra("memName",memName.getText().toString());
			  		intent.putExtra("date",date);			  		
		  	  		intent.putExtra("planNo", ((TextView)careMatters[line].findViewById(R.id.planNo)).getText().toString());
		  	  		intent.putExtra("helperCode",helperCode);
		  	  		intent.putExtra("helperName",helperName);
		  	  		act.startActivity(intent);
				}
				//IsUL^̏ꍇ́uUL^vɑJ
				if(list[which].equals("UL^")){
					Intent intent = new Intent("jp.gihyo.mitoma.careWalk.MAIN");
			  		intent.putExtra("memNo",memNo.getText().toString());
			  		intent.putExtra("memName",memName.getText().toString());
			  		intent.putExtra("date",date);			  		
		  	  		intent.putExtra("planNo", ((TextView)careMatters[line].findViewById(R.id.planNo)).getText().toString());
		  	  		intent.putExtra("helperCode",helperCode);
		  	  		intent.putExtra("helperName",helperName);
		  	  		act.startActivity(intent);
				}
				//Is̑̌ʂ̏ꍇ̓eLXg
				if(list[which].equals("̑̌")){
					etcInput(line);
				}
				//Is͒~ȊO͎sԂ\
				else if(!list[which].equals("͒~")) {
					((TextView)careMatters[line].findViewById(R.id.implTime))
					.setText(time);
					CareView.this.refresh();
				}else{
					((TextView)careMatters[line].findViewById(R.id.result)).setText("");
				}
			}			
		})
		.show();
    }
    /* **********************************************************
     * sʂeLXg
     *************************************************************/
    private void etcInput(int args){ 
    	final EditText dialogBox=new EditText(act);
    	final int line;
    	line=args;
    	new AlertDialog.Builder(act)
		.setIcon(R.drawable.clock_blue)
		.setTitle("̑̌")
		.setView(dialogBox)
		.setPositiveButton("", new DialogInterface.OnClickListener() {				
			public void onClick(DialogInterface dialog, int which) {
				Calendar now = Calendar.getInstance();
				String time=DateFormat.format(CareView.this.act.getString(R.string.f12),now).toString();
				((TextView)careMatters[line].findViewById(R.id.result)).setText(dialogBox.getText());
				((TextView)careMatters[line].findViewById(R.id.implTime))
				.setText(time);
				CareView.this.refresh();
			}
		})
		.show();
    }
    /* **********************************************************
     *̕ҏW
     *************************************************************/
    private String memoWrite(int position){
    	String msg=((TextView)careMatters[position].findViewById(R.id.result)).getText().toString();
    	if(!((TextView)careMatters[position].findViewById(R.id.implTime)).getText().toString().equals("")){
         msg=((TextView)careMatters[position].findViewById(R.id.result)).getText().toString()+
	    	"  "+((TextView)careMatters[position].findViewById(R.id.implTime)).getText().toString();
    	}else{
    		//ǑʂăɕҏW
	    	String careCode=((TextView)careMatters[position].findViewById(R.id.careCode)).getText().toString();
	    	for(int i=0;i<position;i++){
	    		if(careCode.equals(((TextView)careMatters[i].findViewById(R.id.careCode)).getText().toString())){
	    			if(!((TextView)careMatters[i].findViewById(R.id.implTime)).getText().toString().equals("")){
	    				msg="O "+((TextView)careMatters[i].findViewById(R.id.implTime)).getText().toString()+
	    						" " +((TextView)careMatters[i].findViewById(R.id.result)).getText().toString();
	    			}
	    		}
	    	}
    	}
    	return msg;
    }
    /* **********************************************************
     * ̔r
     *************************************************************/
    private int timeComp(String timeA,String timeB){
    	String[] ampmA=timeA.split(" ");
		String[] ampmB=timeB.split(" ");
		if(ampmA.length<=1||ampmB.length<=1)return 0;
		String[] clockA=ampmA[1].split(":");
		String[] clockB=ampmB[1].split(":");
		if(ampmA[0].equals("PM")&&clockA[0].equals("12")){
			clockA[0]="00";
			timeA=ampmA[0]+" "+clockA[0]+":"+clockA[1];
		}
		if(ampmB[0].equals("PM")&&clockB[0].equals("12")){
			clockB[0]="00";
			timeB=ampmB[0]+" "+clockB[0]+":"+clockB[1];
		}		
    	return timeA.compareTo(timeB);
    }
    /* **********************************************************
     * ϊ(24ԁAMPM)
     *************************************************************/
    private String timeConvAmPm(String timeA){    	
		String[] clockA=timeA.split(":");
		if(clockA.length<2)return "";
		Calendar now = Calendar.getInstance();
		now.set(0, 0, 0, Integer.parseInt(clockA[0]), Integer.parseInt(clockA[1]));
		return (String) DateFormat.format("a hh:mm",now);
    }
    /* **********************************************************
     * ϊ(AMPMԁ24)
     *************************************************************/
    private String timeConv24(String timeA){
    	String[] ampmA=timeA.split(" ");
    	if(ampmA.length<2)return "";
		String[] clockA=ampmA[1].split(":");
		if(clockA.length<2)return "";
		int hh=Integer.parseInt(clockA[0]);
		int mm=Integer.parseInt(clockA[1]);
		if(ampmA[0].equals("PM")&&hh!=12)hh+=12;		
		Calendar now = Calendar.getInstance();
		now.set(0, 0, 0, hh, mm);
		return (String)DateFormat.format("kk:mm",now);
    }

}