package jp.gihyo.mitoma.careTimer.activity.model;
import java.util.ArrayList;

import jp.gihyo.mitoma.careTimer.provider.DbProvider;

import android.content.ContentResolver;
import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.net.Uri;
/* *******************************************************************
 * ǎ҂܂
   * @@@R[h̐͏Ж{ōsƂƂAR[h̃Rg͍ŏɂĂ܂B
 *@@@̏ڍא͏ЂB 
 *********************************************************************/
public class CareProvDAO implements CareDAOInterface{
	private ContentResolver resolver;
	private Uri uri=DbProvider.carePlanUri;
	private Uri gUri=DbProvider.carePlanGroupUri;
    public CareProvDAO(Context context){
    	this.resolver=context.getContentResolver();
    }
    /* **********************************************************
     * P̉쎖̌
     *************************************************************/
    public CareDTO selectOne(String memNo,String date,String planNo){
    	CareDTO dto=new CareDTO();
     	String[] select={"memNo","memName","date",
    			"careCode","careName","planNo","predTime","implTime","result",
    			"helperCode","helperName"};
    	String where="memNo=? AND date=? AND planNo=?";
    	String[] whereArgs=new String[3];
    	whereArgs[0]=memNo;
    	whereArgs[1]=date;
    	whereArgs[2]=planNo;
    	String orderBy="predTime";
        Cursor cursol=resolver.query(uri,select,where,whereArgs,orderBy);
       if(cursol.moveToFirst()){
	        dto.setMemNo(cursol.getString(0));
	        dto.setMemName(cursol.getString(1));
	        dto.setDate(cursol.getString(2));
	        dto.setCareCode(cursol.getString(3));
	        dto.setCareName(cursol.getString(4));
	        dto.setPlanNo(cursol.getString(5));
	        dto.setPredTime(cursol.getString(6));
	        dto.setImplTime(cursol.getString(7));
	        dto.setResult(cursol.getString(8));
	        dto.setHelperCode(cursol.getString(9));
	        dto.setHelperName(cursol.getString(10));
	    }
        cursol.close();
        return dto;
    }
    /* **********************************************************
     * P̉v挟
     *************************************************************/
    public ArrayList<CareDTO> selectSet(String memNo,String date){
    	CareDTO dto;
    	ArrayList<CareDTO> careList=new ArrayList<CareDTO>();
    	String[] select={"memNo","memName","date",
    			"careCode","careName","planNo","predTime","implTime","result",
    			"helperCode","helperName"};
    	String where="memNo=? AND date=?";
    	String[] whereArgs=new String[2];
    	whereArgs[0]=memNo;
    	whereArgs[1]=date;
    	String orderBy="predTime";
        Cursor cursol=resolver.query(uri,select,where,whereArgs,orderBy);
       while(cursol.moveToNext()){
    	   dto=new CareDTO();
	        dto.setMemNo(cursol.getString(0));
	        dto.setMemName(cursol.getString(1));
	        dto.setDate(cursol.getString(2));
	        dto.setCareCode(cursol.getString(3));
	        dto.setCareName(cursol.getString(4));
	        dto.setPlanNo(cursol.getString(5));
	        dto.setPredTime(cursol.getString(6));
	        dto.setImplTime(cursol.getString(7));
	        dto.setResult(cursol.getString(8));
	        dto.setHelperCode(cursol.getString(9));
	        dto.setHelperName(cursol.getString(10));
	        careList.add(dto);
        }
        cursol.close();
        return careList;
    }
    /* **********************************************************
     * R
     *************************************************************/
    public ArrayList<CareDTO> selectAny(String where){
    	CareDTO dto;
    	ArrayList<CareDTO> careList=new ArrayList<CareDTO>();
    	String[] select={"memNo","memName","date",
    			"careCode","careName","planNo","predTime","implTime","result",
    			"helperCode","helperName"};
    	String[] whereArgs=null;
      	String orderBy="predTime";
        Cursor cursol=resolver.query(uri,select,where,whereArgs,orderBy);
       while(cursol.moveToNext()){
    	   dto=new CareDTO();
	        dto.setMemNo(cursol.getString(0));
	        dto.setMemName(cursol.getString(1));
	        dto.setDate(cursol.getString(2));
	        dto.setCareCode(cursol.getString(3));
	        dto.setCareName(cursol.getString(4));
	        dto.setPlanNo(cursol.getString(5));
	        dto.setPredTime(cursol.getString(6));
	        dto.setImplTime(cursol.getString(7));
	        dto.setResult(cursol.getString(8));
	        dto.setHelperCode(cursol.getString(9));
	        dto.setHelperName(cursol.getString(10));
	        careList.add(dto);
        }
        cursol.close();
        return careList;
    }
    /* **********************************************************
     * P̉쎖̍폜
     *************************************************************/
    public int deleteOne(String memNo,String date,String planNo){ 
    	String where="memNo=? AND date=? AND planNo=?";
    	String[] whereArgs=new String[3];
    	whereArgs[0]=memNo;
    	whereArgs[1]=date;
    	whereArgs[2]=planNo;
    	return resolver.delete(uri,where,whereArgs);
    }
    /* **********************************************************
     * P̉쎖̍폜
     *************************************************************/
    public int deleteSet(String memNo,String date){ 
    	String where="memNo=? AND date=?";
    	String[] whereArgs=new String[2];
    	whereArgs[0]=memNo;
    	whereArgs[1]=date;
    	return resolver.delete(uri,where,whereArgs);
    }
    /* **********************************************************
     * S폜
     *************************************************************/
    public int deleteAll(){    	
    	return resolver.delete(uri,null,null);
    }
    /* **********************************************************
     * P̉쎖̒ǉ
     *************************************************************/
    public int insertOne(CareDTO dto){
    	ContentValues values=new ContentValues();    	
        values.put("memNo",dto.getMemNo());
        values.put("memName",dto.getMemName());        
        values.put("date",dto.getDate());
        values.put("careCode",dto.getCareCode());
        values.put("careName",dto.getCareName());        
        values.put("planNo",dto.getPlanNo());
        values.put("predTime",dto.getPredTime());
        values.put("implTime",dto.getImplTime());
        values.put("result",dto.getResult());
        values.put("helperCode",dto.getHelperCode());
        values.put("helperName",dto.getHelperName());
       resolver.insert(uri,values);
       return 1;
    }
    /* **********************************************************
     * P̉쎖̒ǉ
     *************************************************************/
    public int insertSet(ArrayList<CareDTO> careList){
    	int count=0;
    	for(int i=0;i<careList.size();i++){
    		this.insertOne(careList.get(i));
    		count++;
    	}
    	return count;
    }
    /* **********************************************************
     * P̉쎖̍XV
     *************************************************************/
    public int updateOne(CareDTO dto){
    	String where="memNo=? AND date=? AND planNo=?";
    	String[] whereArgs=new String[3];
    	whereArgs[0]=dto.getMemNo();
    	whereArgs[1]=dto.getDate();
    	whereArgs[2]=dto.getPlanNo();
        ContentValues values=new ContentValues();
        values.put("memNo",dto.getMemNo());
        values.put("memName",dto.getMemName());        
        values.put("date",dto.getDate());
        values.put("careCode",dto.getCareCode());
        values.put("careName",dto.getCareName());        
        values.put("planNo",dto.getPlanNo());
        values.put("predTime",dto.getPredTime());
        values.put("implTime",dto.getImplTime());
        values.put("result",dto.getResult());
        values.put("helperCode",dto.getHelperCode());
        values.put("helperName",dto.getHelperName());
        return resolver.update(uri,values,where,whereArgs);
    }
    /* **********************************************************
     * P̉쎖̍XV
     *************************************************************/
    public int updateSet(ArrayList<CareDTO> careList){
    	int count=0;
    	for(int i=0;i<careList.size();i++){
    		this.updateOne(careList.get(i));
    		count++;
    	}
    	return count;
    }
    /* **********************************************************
     * ҂ƓtŃO[vČ
     *************************************************************/
	public ArrayList<CareDTO> selectGroup(String where) {
    	CareDTO dto;
    	ArrayList<CareDTO> careList=new ArrayList<CareDTO>();
    	String[] select={"memNo","date"};
    	String orderBy="memNo asc,date desc";
        Cursor cursol=resolver.query(gUri,select,where,null,orderBy);
       while(cursol.moveToNext()){
    	   dto=new CareDTO();
	        dto.setMemNo(cursol.getString(0));
	        dto.setDate(cursol.getString(1));
	        careList.add(dto);
        }
        cursol.close();
		return careList;
	}
}
