package jp.gihyo.android.exercise06.service;

import java.util.ArrayList;
import jp.gihyo.android.exercise.R;
import jp.gihyo.android.exercise06.model.CareDTO;

import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.os.IBinder;
import android.util.Log;

/* *******************************************************************
 * ǎ҂܂
   * @@@R[h̐͏Ж{ōsƂƂAR[h̃Rg͍ŏɂĂ܂B
 *@@@̏ڍא͏ЂB 
 *********************************************************************/
public class CarePlanService extends Service implements Runnable{
    private Thread thread;
    private PlanWebDAO webDAO;
    final static String INSERT="jp.gihyo.exercise.carePlan.INSERT";
    final static String UPDATE="jp.gihyo.exercise.carePlan.UPDATE";
    final static String DELETE="jp.gihyo.exercise.carePlan.DELETE";
    
    @Override
    public void onCreate(){
    	Log.d("CareService", "Create now");
    	this.thread=null;
    	this.webDAO=new PlanWebDAO(this);
    }
    @Override
    public void onStart(Intent intent,int startID) {
    	Log.d("CareService", "Start now");
    	//L[ւ̊i[
    	while(!Queue.getInstance().enq(intent)){
    		//L[ς̂ƂQb҂čēxi[
    		Log.d("CareService", "Wait now");
    		try{Thread.sleep(2000);}catch(Exception e){}
    	}
    	//Xbh~̏ꍇX^[g
    	if(this.thread ==null){
    		this.thread=new Thread(this);
    		this.thread.start();
    	}    	
    }
    //stopService()̏
    @Override
    public void onDestroy() {
    	super.onDestroy();
    	Log.d("CarePlanService", "Destroy now");
    	this.thread=null;
    }
    /* *****************************************************************
     * ̖{(L[IntentoT[o֑M)
     *******************************************************************/
	public void run() {		
		int retry=0;
		//L[`FbN
		checkQueue();
		//L[łTĎ
		while(retry++<5){
			Intent intent=Queue.getInstance().deq();
			//L[ɂȂ܂ŌJԂ
	    	while(intent!=null){
	    		Log.d("CarePlanService", "Running now "+intent.getStringExtra("procType"));
	    		CareDTO careDTO=(CareDTO) intent.getSerializableExtra("careDTO");
	    		if(careDTO==null)continue;
	    		if(intent.getAction().equals(INSERT))webDAO.insertOne(careDTO);
	    		if(intent.getAction().equals(UPDATE))webDAO.updateOne(careDTO);
	    		if(intent.getAction().equals(DELETE))webDAO.deleteOne("","","");
	    		intent=Queue.getInstance().deq();
	    		retry=0;
	    		checkQueue();
	    	}
	    	Log.d("CarePlanService", "Sleep now "+retry);
	    	try{Thread.sleep(3000);}catch(Exception e){}
		}
    	Log.d("CarePlanService", "Stop now");
    	stopSelf();
	}
    @Override
    public IBinder onBind(Intent intent) {
        return null;   
    }
    /* *****************************************************************
     * L[̏Ԃ`FbNCTO%ȏ̑ؗ΃meBtBP[Vɕ\
     *******************************************************************/
    private void checkQueue(){
    	NotificationManager nm=(NotificationManager)getSystemService(Context.NOTIFICATION_SERVICE);
    	if(Queue.getInstance().getArray().size()<1)return;
    	if(Queue.QUEUE_SIZE/Queue.getInstance().getArray().size()<2){
	  		Notification notif=new Notification();
	  		notif.icon=R.drawable.caution;
	  		notif.defaults |=Notification.DEFAULT_SOUND;
	  		notif.flags |=Notification.FLAG_AUTO_CANCEL;
	  		notif.when=System.currentTimeMillis();
	  		PendingIntent pi = 
		            PendingIntent.getActivity(getApplicationContext(), 0, new Intent(), 0);
	  		notif.setLatestEventInfo(getApplicationContext(), "T[ȏ","XV}ĉB", pi);
	  		nm.notify(0, notif);
    	}else nm.cancel(0);
    }
}
/* *****************************************************************
 * ҂s(ArrayListgp)
 *******************************************************************/
class Queue{
	private static ArrayList<Intent> array; 
	private static Queue instance=null;
	final static int QUEUE_SIZE=24;
	private Queue(){
    	array=new ArrayList<Intent>();
    }
	public static synchronized Queue getInstance(){
    	if(instance==null){
    		instance=new Queue();
    	}
    	return instance;
    }
	//o
	public synchronized Intent deq(){
		Intent intent=null;
		if(!array.isEmpty()){
			intent=array.get(0);
			array.remove(0);
			array.trimToSize();
		}
		return intent;
	}
	//i[
	public synchronized boolean enq(Intent intent){
		if(array.size()>=QUEUE_SIZE)return false;
		array.add(intent);
		return true;
	}
	//L[Ŝ̎o
	public ArrayList<Intent> getArray(){return array; } 	
}
